-- Copyright 2011 Xavier Ferrair aka Mortimer @ Outland [H] (deadlygm@gmail.com)
-- no code in this file may be used in other works without expressed permission

local L = BANGBANGLOCALES

local BB_Version = tonumber(GetAddOnMetadata("Bang_Bang", "Version"));

local f = CreateFrame("Frame")
f:RegisterEvent("PLAYER_LOGIN")
f:RegisterEvent("ADDON_LOADED");
f:RegisterEvent("PLAYER_ENTERING_WORLD");
f:SetScript("OnEvent", function(self, event, ...)
    if event == "ADDON_LOADED" and ... == "Bang_Bang" then
        if not BangCharDB then BangCharDB = {} end
			if BangCharDB.MinimapPos == nil then
			BangCharDB = { MinimapPos = 45 }
			else
				BANG_MinimapButton_Reposition()
				self:UnregisterEvent("ADDON_LOADED");
			end
	end
	
	if (event == "PLAYER_ENTERING_WORLD") then
		if not IsAddOnLoaded("Blizzard_PVPUI") then
			LoadAddOn("Blizzard_PVPUI")
		end
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFD800Bang! Bang! |cff2EFE2E"..BB_Version.." |cffDDDDDDloaded");
		--DEFAULT_CHAT_FRAME:AddMessage("|cffFFD800Bang! Bang! |cff2EFE2E"..BB_Version.." |cffFE2E2EAurka |cffCCCCCCversion");
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
    end

end)

SLASH_BB1 = "/bb";
local function BBCmdLine(op)
	local rl = GetRealmName()
	local tcd = GetUnitName("target", true)
	local tg = UnitGUID("target")
	if ( op == "add" ) then
		if tcd ~= nil and tcd == GetUnitName("target", true) then
		local esPlayer = strsplit("-",tg)
			if esPlayer == "Player" then
				if string.find(tcd, '%-') then end
				if not string.find(tcd, '%-') then tcd = (tcd.."-"..rl) end
			else
				tcd = tcd
			end
			BangHateds[tcd] = true;
			print("|cff009900+ Added |r" ..tcd.." |cff009900to wanted list.")
		else
			print("Please, must to have a target.")
		end
	elseif ( op == "del" ) then
		if tcd ~= nil and tcd == GetUnitName("target", true) then
		local esPlayer = strsplit("-",tg)
			if esPlayer == "Player" then
				if string.find(tcd, '%-') then end
				if not string.find(tcd, '%-') then tcd = (tcd.."-"..rl) end
			else
				tcd = tcd
			end
			BangHateds[tcd] = nil;
			print("|cffFE2E2E- "..L.W_DELED.." |r" ..tcd.." |cffFE2E2E"..L.W_FROM)
		else
			print("Please, must to have a target.")
		end
	else
		BangGetOnClick()
	end
end
SlashCmdList["BB"] = BBCmdLine;

function BANG_MinimapButton_Reposition()
	BANG_MinimapButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-(80*cos(BangCharDB.MinimapPos)),(80*sin(BangCharDB.MinimapPos))-52)
	BANG_MinimapButton:RegisterForClicks("AnyUp");
	BANG_MinimapButton:SetScript("OnClick", function(self, button)
		if button == "LeftButton" then BangGetOnClick() end
		if button == "RightButton" then BangGetOnRClick() end
	end)

	hooksecurefunc("ToggleGameMenu", function() BBGui:Hide() end)
	BANG_MinimapButton:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	BANG_MinimapButton:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
			local h, _ = GetPVPSessionStats("player")
			local hk, _ = GetPVPLifetimeStats("player")
			local r = GetPersonalRatedInfo(1) --2v2
			local rr = GetPersonalRatedInfo(2) --3v3
			local rrr = GetPersonalRatedInfo(4) --10v10
	GameTooltip:AddLine("|cffFFD800Bang! Bang! "..BB_Version, 1, 0.82, 0, 1)
	GameTooltip:AddLine("Release version", 0, 0.82, 0, 1)
	--GameTooltip:AddLine("Aurka version", 0, 0.82, 0, 1)
	GameTooltip:AddLine("|cffFE2E2EHks: |cffDDDDDD"..h.." |cff777777"..hk, 0, 0.82, 0, 1)
	GameTooltip:AddLine("|cffdf74012v2:|cffDDDDDD "..r.." |cffdf74013v3:|cffDDDDDD "..rr.." |cffdf740110v10:|cffDDDDDD "..rrr, 0, 0.82, 0, 1)
	GameTooltip:Show()
	end)
end

-- Only while the button is dragged this is called every frame
function BANG_MinimapButton_DraggingFrame_OnUpdate()

	local xpos,ypos = GetCursorPosition()
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom()

	xpos = xmin-xpos/UIParent:GetScale()+70
	ypos = ypos/UIParent:GetScale()-ymin-70

	BangCharDB.MinimapPos = math.deg(math.atan2(ypos,xpos))
	BANG_MinimapButton_Reposition()
end


function BangGetOnClick()
	bangBraks()
	BBGui:Show()
	BBGui.f1f:Show()
	BBGui.f2f:Hide()
	BBGui.f3f:Hide()
	BBGui.f4f:Hide()
end

function BangGetOnRClick()
	local r = GetPersonalRatedInfo(1)
	local rr = GetPersonalRatedInfo(2)
	local rrr = GetPersonalRatedInfo(4)
	local url = "2v2: "..r.." - 3v3: "..rr.." - 10v10: "..rrr
	if url then
		local edit_box = ChatEdit_ChooseBoxForSend()
		ChatEdit_ActivateChat(edit_box)
		if url then
			edit_box:Insert("");
			edit_box:Insert(url);
			edit_box:HighlightText();
		end
	end
end
